/*********************************************************************************
This script was made by milt.

Website: www.pvpzone.net

Special thanks to KillerBeeZ for the idea.
*********************************************************************************/
using System;
using System.Collections;
using Server;
using System.Reflection;
using Server.Items;

namespace Server.Scripts.Commands
{
	public class GlobalReplace
	{
		public static void Initialize()
		{
			Server.Commands.Register( "GlobalReplace", AccessLevel.Administrator, new CommandEventHandler( GlobalReplace_OnCommand ) );
		}

		[Usage( "GlobalReplace" )]
		[Description( "Replaces all items of one type to another." )]
		private static void GlobalReplace_OnCommand( CommandEventArgs e )
		{
			string toReplace;
			string Replacer;

			try
			{
				toReplace = e.Arguments[0];
				Replacer = e.Arguments[1];
			}

			catch
			{
				e.Mobile.SendMessage( 1154, "Invalid arguments" );
				return;
			}

			object ob;
			int count = 0;
			ArrayList list = new ArrayList();

			try
			{
				if(toReplace != "" && Replacer != "")
				{
					Type item1 = ScriptCompiler.FindTypeByName( toReplace );
					Type item2 = ScriptCompiler.FindTypeByName( Replacer );

					if( item1 != null && item2 != null )
					{
						ob = Activator.CreateInstance( item1 );

						if(!(ob is Item))
						{
							e.Mobile.SendMessage( 1154, "Sorry, only items are supported." );
							return;
						}

						else if( ob is Item )
						{
							foreach( Item i in World.Items.Values )
							{
								if( i.GetType() == item1 )
								{
									list.Add(i);
									++count;
								}
							}

							HandleArray(item2, e.Mobile, count, list);
						}
					}

					else
					{
						e.Mobile.SendMessage( 1154, "Invalid arguments" );
						return;
					}
				}

				else
				{
					e.Mobile.SendMessage( 1154, "Invalid arguments" );
					return;
				}
			}

			catch
			{
				e.Mobile.SendMessage( 1154, "Either the arguments that you provided are invalid, or an error occured." );
				return;
			}
		}

		private static void HandleArray(Type type, Mobile from, int count, ArrayList ary)
		{
			object f;
			Type inst = type;
			ArrayList list = ary;

			foreach(Item item in new ArrayList( list ))
			{
				f = Activator.CreateInstance( inst );

				Item o = (Item)f;

				if( item.Parent is Container )
				{
					if( item.Stackable && o.Stackable )
					{
						
						((Container)item.Parent).AddItem( o );
						o.Location = item.Location;
						o.Amount = item.Amount;
						item.Delete();
					}

					else
					{
						((Container)item.Parent).AddItem( o );
						o.Location = item.Location;
						item.Delete();
					}
				}

				else if( item.Parent is Mobile )
				{
					if( item.Stackable && o.Stackable )
					{
						((Mobile)item.Parent).AddItem( o );
						o.Amount = item.Amount;
						item.Delete();
					}

					else
					{
						((Mobile)item.Parent).AddItem( o );
						item.Delete();
					}
				}

				else
				{
					if( item.Stackable && o.Stackable )
					{
						o.Location = item.Location;
						o.Map = item.Map;
						o.MoveToWorld( item.Location, item.Map ); //Double checks
						o.Amount = item.Amount;
						item.Delete();
					}

					else
					{
						o.Location = item.Location;
						o.Map = item.Map;
						o.MoveToWorld( item.Location, item.Map ); //Double checks
						item.Delete();
					}
				}
			}

			from.SendMessage( 1154, "Process completed successfully. {0} items were replaced successfully.", count );
			from.SendMessage( 1154, "Done. Thank you for using Milt's global replace command.");
		}
	}
}